/*
 * cplugin.cpp
 * 
 * original(csaori.cpp)
 * written by Ukiya http://ukiya.sakura.ne.jp/
 * based by тl "gethwnd.dll"
 */

#ifdef _MSC_VER
#pragma warning( disable : 4786 )
#endif

#include <cstring>
#include <cstdlib>
#include <algorithm>
#include <locale>
#include <sstream>
#include <iterator>

#include "cplugin.h"
#include <boost/tokenizer.hpp>
#include <boost/lexical_cast.hpp>
#include "global.h"
#include "debug.h"

//////////DEBUG/////////////////////////
#ifdef _WINDOWS
#ifdef _DEBUG
#include <crtdbg.h>
#define new new( _NORMAL_BLOCK, __FILE__, __LINE__)
#endif
#endif
////////////////////////////////////////

//global CPLUGIN object
CPLUGIN* pPlugin;

//------------------------------------------------------------------------------
//֐
//------------------------------------------------------------------------------
namespace PLUGIN_FUNC{
	std::string UnicodeToMultiByte(const std::wstring& Source, UINT CodePage, DWORD Flags)
	{
	  if (int Len = ::WideCharToMultiByte(CodePage, Flags, Source.c_str(), static_cast<int>(Source.size()), NULL, 0, NULL, NULL)) {
		std::vector<char> Dest(Len);
		if (Len = ::WideCharToMultiByte(CodePage, Flags, Source.c_str(), static_cast<int>(Source.size()), &Dest[0], static_cast<int>(Dest.size()), NULL, NULL)) {
		  return std::string(Dest.begin(), Dest.begin() + Len);
		}
	  }
	  return "";
	}


	std::wstring MultiByteToUnicode(const std::string& Source, UINT CodePage, DWORD Flags)
	{
	  if (int Len = ::MultiByteToWideChar(CodePage, Flags, Source.c_str(), static_cast<int>(Source.size()), NULL, 0)) {
		std::vector<wchar_t> Dest(Len);
		if (Len = ::MultiByteToWideChar(CodePage, 0, Source.c_str(), static_cast<int>(Source.size()), &Dest[0], static_cast<int>(Dest.size()))) {
		  return std::wstring(Dest.begin(), Dest.begin() + Len);
		}
	  }
	  return L"";
	}

	UINT CHARSETtoCodePage(CHARSET cset){
		switch(cset){
			case CHARSET_Shift_JIS:
				return 932;
			case CHARSET_ISO_2022_JP:
				return 50220;
			case CHARSET_EUC_JP:
				return 20932;
			case CHARSET_UTF_8:
				return CP_UTF8;
		}
		return CP_ACP;
	}

	std::wstring CHARSETtoString(CHARSET cset){
		switch(cset){
			case CHARSET_Shift_JIS:
				return L"Shift_JIS";
			case CHARSET_ISO_2022_JP:
				return L"ISO-2022-JP";
			case CHARSET_EUC_JP:
				return L"EUC-JP";
			case CHARSET_UTF_8:
				return L"UTF-8";
		}
		return L"unknown charset";
	}

	string_t getResultString(int rc)
	{
		char_t	*p;
		
		switch(rc) {
			case 200:
				p = L"OK"; break;
			case 204:
				p = L"No Content"; break;
			case 210:
				p = L"Break"; break;		// SSTP Break (SSTP session aborted)
			case 300:
				p = L"Communicate"; break; // (obsolete)
			case 311:
				p = L"Not Enough"; break; // SHIORI/2.4 TEACH...need more info.
			case 312:
				p = L"Advice"; break; // SHIORI/2.4 TEACH...drop recent reference
			case 400:
				p = L"Bad Request"; break;
			case 401:
				p = L"Unauthorized"; break;
			case 403:
				p = L"Forbidden"; break;
			case 404:
				p = L"Not Found"; break;
			case 405:
				p = L"Method Not Allowed"; break;
			case 406:
				p = L"Not Acceptable"; break;
			case 408:
				p = L"Request Timeout"; break;
			case 409:
				p = L"Conflict"; break;
			case 420:
				p = L"Refuse"; break;		// SSTP refused by ghost
			case 500:
				p = L"Internal Server Error"; break;
			case 501:
				p = L"Not Implemented"; break;
			case 503:
				p = L"Service Unavailable"; break;
			case 510:
				p = L"Not Local IP"; break;	// SSTP from Non-Local IP
			case 511:
				p = L"In Black List"; break;	// SSTP from "Black-Listed" IP
			case 512:
				p = L"Invisible"; break;	// SSTP inivisible (not proceed)
			default:
				p = L"Unknown Error";
		}
		
		return string_t(p);
	}

	//
	// string  tpos ʒu炩Psis͏I[܂Łjo 
	// ߂l ... sJnʒuisȂƂ string::nposj 
	//
	string_t::size_type getLine(string_t &sl, const string_t &src, string_t::size_type tpos)
	{
		string_t::size_type len = src.size();
		if (tpos == string_t::npos || tpos >= len) {
			sl = L"";
			return string_t::npos;
		}
		string_t::size_type  ppos = src.find_first_of(L"\r\n", tpos);
		if (ppos == string_t::npos) {
			sl = src.substr(tpos);
			return ppos;
		}
		sl = src.substr(tpos, ppos - tpos);
		ppos++;
		if (ppos >= len) return string_t::npos;
		if (src[ppos - 1] == '\r' && src[ppos] == '\n') {
			ppos++;
			if (ppos >= len) return string_t::npos;
		}
		
		return ppos;
	}

	//
	// numToString(num, base, sign)
	// Ȃl 
	// num l 
	// base iftHg 10j 
	// sign ʕ̐擪ɂ镶B\0 ̏ꍇ͉Ȃ 
	//
	// intToString(num, base)
	// l 
	// numToString ƂB̂Ƃ - 擪ɂ 
	//
	string_t numToString(unsigned num, unsigned int base, char_t sign)
	{
		if (num == 0) return L"0";
		
		unsigned m;
		char_t	c, s[96];
		int		pos = sizeof(s);
		
		s[--pos] = '\0';
		while(pos > 0) {
			m = num % base;
			if (m < 10) c = L'0' + m;
			else c = L'a' - 10 + m;
			s[--pos] = c;
			num /= base;
			if (num == 0) break;
		}
		if (sign) s[--pos] = sign;
		
		return string_t(s + pos);
	}

	string_t intToString(int num, unsigned int base)
	{
		char_t c = L'\0';
		if (num < 0) { num = -num; c = '-'; }
		return PLUGIN_FUNC::numToString(num, base, c);
	}

	void splitString(const string_t &input, const string_t &split, std::vector<string_t> &output)
	{
		string_t::size_type pos1 = 0,pos2 = 0;
		while(pos2 != string_t::npos)
		{
			pos2 = input.find(split,pos1);
			output.push_back(input.substr(pos1,(pos2==string_t::npos)?pos2:(pos2-pos1)));
			pos1 = pos2;
			pos1++; 
		}
		return;
	}

	void registerEvent(const string_t &event_name, const std::vector<string_t> &refernce)
	{
		CPLUGINQueueEvent evt(event_name,refernce);
		pPlugin->event_queue.push(evt);

		return;
	}
}

CPLUGINQueueEvent::CPLUGINQueueEvent(const string_t &evt,const std::vector<string_t> &ref)
	:event_name(evt),reference(ref)
{
}
CPLUGINQueueEvent::CPLUGINQueueEvent(const CPLUGINQueueEvent &obj)
	:event_name(obj.event_name),reference(obj.reference)
{
}

//------------------------------------------------------------------------------
//CPLUGINInput
//------------------------------------------------------------------------------
bool CPLUGINInput::parseString(const string_t &src)
{
	const char_t atag[] = L"Reference";
	const string_t::size_type catag = 9;//"Reference"̒
	string_t::size_type pos = 0, nextpos;
	string_t::size_type ts;
	std::vector<string_t> _reference;
	//std::map<string_t, string_t> _opt;
	string_t _cmd;
	string_t _id;
	string_t _sender;

	string_t sl;
	
	pos = PLUGIN_FUNC::getLine(sl, src, pos);
	ts = sl.find(L" PLUGIN/2.0");
	if (ts == string_t::npos) return false;
	_cmd = sl.substr(0, ts);
	
	string_t k, v;
	int argc = 0;
	
	while(1) {
		sl = L"";
		nextpos = PLUGIN_FUNC::getLine(sl, src, pos);
		ts = sl.find(L": ");
		if (ts != string_t::npos) {
			k = sl.substr(0, ts);
			v = sl.substr(ts + 2);
			const char_t *pk = k.c_str();
			// _reference[n]  vector (_args) ɐς
			if (k.size() > catag && _memicmp(pk, atag, catag) == 0) {
				int ord = _wtoi(pk + catag);
				if (ord > 0 || (ord == 0 && k[catag] == L'0')) {
					if (argc <= ord) {
						// _reference[n] ԂɓĂȂꍇ 
						// Ԃɖ߂Ă 
						for(int i=(int)(_reference.size()); i<=ord; i++) {
							_reference.push_back(L"");
						}
					}
					//_arg.push_back(v);
					_reference[ord]=v;
					argc = (int)(_reference.size());
				}
			}
			else if (k.size() > 1 && _memicmp(pk, L"ID", 2) == 0) {
				_id = v;
			}
			else if (k.size() > 5 && _memicmp(pk, L"Sender", 6) == 0) {
				_sender = v;
			}
			else {
				// nothing do
				/*if (ts > 0) {
					std::map<string_t,string_t>::iterator i;
					i = _opt.find(k);
					if (i == _opt.end()) {
						_opt.insert(std::pair<string_t,string_t>(k, v));
					}
					else _opt[k] = v;
				}*/
			}
		}
		if (nextpos == string_t::npos) break;
		pos = nextpos;
	}
	cmd=_cmd;
	id = _id;
	sender=_sender;
	references=_reference;
	//opts=_opt;
	return true;
}

//------------------------------------------------------------------------------
//CPLUGINOutput
//------------------------------------------------------------------------------
namespace {
	inline bool output_header(std::wstringstream &dest,const char_t *name,const string_t &value) {
		if (!value.empty()) {
			dest << name << L": " << value << L"\r\n";
			return true;
		}
		return false;
	}
};

string_t CPLUGINOutput::toString()
{
	string_t rcstr = PLUGIN_FUNC::getResultString(result_code);
	
	std::wstringstream dest;
	dest << PLUGIN_VERSIONSTRING L" ";
	dest << result_code << L" " << rcstr << L"\r\n";

	dest << L"Charset: " << PLUGIN_FUNC::CHARSETtoString(charset) << L"\r\n";
	
	if (!references.empty()) {
		int i, n = (int)(references.size());
		string_t tmp;
		for(i=0; i<n; i++) {
			dest << L"Reference" << i << L": ";

			tmp = references[i];
			std::string::size_type nPos = 0;
			while((nPos = tmp.find(L"\r\n", nPos)) != std::string::npos){
				tmp.replace(nPos, 2 , L"\1");
			}
			while((nPos = tmp.find(L"\r", nPos)) != std::string::npos){
				tmp.replace(nPos, 2 , L"\1");
			}
			while((nPos = tmp.find(L"\n", nPos)) != std::string::npos){
				tmp.replace(nPos, 2 , L"\1");
			}

			dest << references[i] << L"\r\n";
		}
	}

	output_header(dest,L"Target",target);
	if (output_header(dest,L"Event",event)) {
		if (event_opt == PLUGINEVENTOPTION_NOTIFY) {
			dest << L"EventOption: notify\r\n";
		}
	}
	if (output_header(dest,L"Script",script)) {
		if (script_opt != PLUGINSCRIPTOPTION_NONE) {
			dest << L"ScriptOption: ";
			if (script_opt == PLUGINSCRIPTOPTION_NOTRANSLATE) {
				dest << L"notranslate";
			}
			else if (script_opt == PLUGINSCRIPTOPTION_NOBREAK) {
				dest << L"nobreak";
			}
			else if (script_opt == (PLUGINSCRIPTOPTION_NOBREAK|PLUGINSCRIPTOPTION_NOTRANSLATE)) {
				dest << L"notranslate,nobreak";
			}
			dest << L"\r\n";
		}
	}
	
	dest << L"\r\n";
	return dest.str();
}

string_t CPLUGINOutput::toStringForVersion(const string_t &version)
{
	string_t rcstr = PLUGIN_FUNC::getResultString(result_code);
	
	std::wstringstream dest;
	dest << PLUGIN_VERSIONSTRING L" ";
	dest << result_code << L" " << rcstr << L"\r\n";

	dest << L"Charset: " << PLUGIN_FUNC::CHARSETtoString(CHARSET_UTF_8) << L"\r\n";
	
	dest << L"Value:"<< version <<L"\r\n\r\n";
	return dest.str();
}

//------------------------------------------------------------------------------
//CPLUGINGhostInfo
//------------------------------------------------------------------------------
CPLUGINGhostInfo::CPLUGINGhostInfo(const std::vector<string_t> &reference)
{
	init(reference);
}

CPLUGINGhostInfo::CPLUGINGhostInfo(const CPLUGINGhostInfo &obj)
{
	hwnd_list = obj.hwnd_list;
	ghost_name = obj.ghost_name;
	shell_name = obj.shell_name;
	id = obj.id;
	path = obj.path;
}

CPLUGINGhostInfo &CPLUGINGhostInfo::operator =(const CPLUGINGhostInfo &obj)
{
	hwnd_list = obj.hwnd_list;
	ghost_name = obj.ghost_name;
	shell_name = obj.shell_name;
	id = obj.id;
	path = obj.path;
	return (*this);
}

void CPLUGINGhostInfo::init(const std::vector<string_t> &reference)
{
	typedef boost::char_separator<char_t> char_separator;
	typedef boost::tokenizer<char_separator,string_t::const_iterator,string_t> tokenizer;

	char_separator sep(L"\1", L"", boost::keep_empty_tokens);
	tokenizer tokens(reference[0], sep);
	
	tokenizer::iterator itr = tokens.begin(),
						last = tokens.end();

	for(; itr != last; ++itr) {
		hwnd_list.push_back(reinterpret_cast<HWND>(boost::lexical_cast<DWORD>(*itr)));
	}

	ghost_name = reference[1];
	shell_name = reference[2];
	id = reference[3];
	path = reference[4];

	return;
}

string_t CPLUGINGhostInfo::toString(void)const
{
	std::basic_ostringstream<char_t> os;
	os << L"HWND: ";
	std::vector<HWND>::const_iterator itr = hwnd_list.begin(),
									  last = hwnd_list.end();
	for(;itr!=last;++itr)
	{
		os << reinterpret_cast<DWORD_PTR>(*itr) << L",";
	}
	os << std::endl
		<< L"Ghost: "	<< ghost_name << std::endl
		<< L"Shell: "	<< shell_name << std::endl
		<< L"ID: "		<< id << std::endl
		<< L"Path: "	<< path << std::endl;
	return os.str();
}

//------------------------------------------------------------------------------
//CPLUGIN
//------------------------------------------------------------------------------
std::string CPLUGIN::request(const std::string &rq_tmp)
{
	std::string cmd;
	CPLUGINInput* pIn;
	CPLUGINOutput* pOut;

	//HRequestɕϊ
	std::string tmp=rq_tmp;
	std::transform(tmp.begin(), tmp.end(), tmp.begin(), tolower);

	//Charset
	CHARSET cset=CHARSET_Shift_JIS;
	if(tmp.find("\ncharset: shift_jis")!=std::string::npos){
		cset=CHARSET_Shift_JIS;
	}else if(tmp.find("\ncharset: iso-2022-jp")!=std::string::npos){
		cset=CHARSET_ISO_2022_JP;
	}else if(tmp.find("\ncharset: euc-jp")!=std::string::npos){
		cset=CHARSET_EUC_JP;
	}else if(tmp.find("\ncharset: utf-8")!=std::string::npos){
		cset=CHARSET_UTF_8;
	}

	//ϊ
	string_t rq=PLUGIN_FUNC::MultiByteToUnicode(rq_tmp,PLUGIN_FUNC::CHARSETtoCodePage(cset));

	//͏Jn
	pIn=new CPLUGINInput();
	pIn->charset=cset;
	//pIn->opts[L"SecurityLevel"] = L"Local";
	bool result=pIn->parseString(rq);

	pOut=new CPLUGINOutput();
	pOut->charset=pIn->charset;
	pOut->event_opt = PLUGINEVENTOPTION_NONE;
	pOut->script_opt = PLUGINSCRIPTOPTION_NONE;
	if(result==false){
		pOut->result_code=PLUGINRESULT_INTERNAL_SERVER_ERROR;
	}else{
		if (pIn->cmd == L"GET" || pIn->cmd == L"NOTIFY") {
			//MessageBox(0,pIn->id.c_str(),L"",0);
			if (system_function_table.count(pIn->id) == 1) {
				if (!system_function_table[pIn->id].empty())
					system_function_table[pIn->id](*this,*pIn,*pOut);
			}
			if (function_table.count(pIn->id) == 1) {
				if (!function_table[pIn->id].empty())
					function_table[pIn->id](*this,*pIn,*pOut);
			}
		}else {
			pOut->result_code=PLUGINRESULT_BAD_REQUEST;
		}
	}
	
	string_t res_wstr=(pIn->id == L"version")?pOut->toStringForVersion(version):pOut->toString();
	std::string res_str=PLUGIN_FUNC::UnicodeToMultiByte(res_wstr,PLUGIN_FUNC::CHARSETtoCodePage(pOut->charset));
	delete pIn;
	delete pOut;
	return res_str;
}

void CPLUGIN::setModulePath(const std::string &str){
	module_path=PLUGIN_FUNC::MultiByteToUnicode(str);
}

const string_t &CPLUGIN::getModulePath(void)const{
	return module_path;
}
const std::vector<CPLUGINListInfo> &CPLUGIN::getPluginList(void)const{
	return plugin_list;
}
const std::vector<string_t> &CPLUGIN::getGhostPathList(void)const{
	return ghost_path_list;
}
const std::vector<string_t> &CPLUGIN::getBalloonPathList(void)const{
	return balloon_path_list;
}
const std::vector<string_t> &CPLUGIN::getHeadlinePathList(void)const{
	return headline_path_list;
}
const std::vector<string_t> &CPLUGIN::getPluginPathList(void)const{
	return plugin_path_list;
}
const std::vector<CPLUGINGhostInfo> &CPLUGIN::getGhostInfoList(void)const{
	return ghost_info_list;
}

void installedplugin__(CPLUGIN& base,const CPLUGINInput &in,CPLUGINOutput &out) {
	//MessageBox(0,L"installplugin",L"",0);
	std::vector<string_t>::const_iterator
		itr=in.references.begin(),
		last=in.references.end();
	std::vector<CPLUGINListInfo> _list;
	std::vector<string_t> tmp;
	CPLUGINListInfo info;

	for(;itr!=last;++itr)
	{
		PLUGIN_FUNC::splitString(*itr,L"\1",tmp);
		info.name = tmp[0];
		info.id = tmp[1];
		_list.push_back(info);
		tmp.clear();
	}

	base.plugin_list = _list;
	out.result_code = PLUGINRESULT_NO_CONTENT;
	//MessageBox(0,L"installplugin end",L"",0);
	return;
}

void ghostpathlist__(CPLUGIN& base,const CPLUGINInput &in,CPLUGINOutput &out) {
	//MessageBox(0,L"ghostpath",L"",0);
	std::vector<string_t> _list(in.references.begin(),in.references.end());
	base.ghost_path_list = _list;
	out.result_code = PLUGINRESULT_NO_CONTENT;
	return;
}
void balloonpathlist__(CPLUGIN& base,const CPLUGINInput &in,CPLUGINOutput &out) {
	//MessageBox(0,L"balloonpath",L"",0);
	std::vector<string_t> _list(in.references.begin(),in.references.end());
	base.balloon_path_list = _list;
	out.result_code = PLUGINRESULT_NO_CONTENT;
	return;
}
void headlinepathlist__(CPLUGIN& base,const CPLUGINInput &in,CPLUGINOutput &out) {
	//MessageBox(0,L"headlinepath",L"",0);
	std::vector<string_t> _list(in.references.begin(),in.references.end());
	base.headline_path_list = _list;
	out.result_code = PLUGINRESULT_NO_CONTENT;
	return;
}
void pluginpathlist__(CPLUGIN& base,const CPLUGINInput &in,CPLUGINOutput &out) {
	//MessageBox(0,L"pluginpath",L"",0);
	std::vector<string_t> _list(in.references.begin(),in.references.end());
	base.plugin_path_list = _list;
	out.result_code = PLUGINRESULT_NO_CONTENT;
	return;
}

void OnGhostInfoUpdate__(CPLUGIN& base,const CPLUGINInput &in,CPLUGINOutput &out) {
	//MessageBox(0,L"OnGhostInfoUpdate",L"",0);
	std::vector<CPLUGINGhostInfo>::iterator itr = base.ghost_info_list.begin(),
											last = base.ghost_info_list.end();
	for(;itr!=last;++itr)
	{
		if(itr->id == in.references[3])
		{
			itr->init(in.references);
			out.result_code = PLUGINRESULT_NO_CONTENT;
			//DebugMsg(itr->toString());
			//DebugMsg(base.ghost_info_list.size());
			return;
		}
	}
	CPLUGINGhostInfo info(in.references);
	base.ghost_info_list.push_back(info);
	out.result_code = PLUGINRESULT_NO_CONTENT;
	//DebugMsg(info.toString());
	//DebugMsg(base.ghost_info_list.size());
	return;
}

void OnGhostBoot__(CPLUGIN& base,const CPLUGINInput &in,CPLUGINOutput &out) {
	//MessageBox(0,L"OnGhostBoot",L"",0);
	CPLUGINGhostInfo info(in.references);
	base.ghost_info_list.push_back(info);
	out.result_code = PLUGINRESULT_NO_CONTENT;
	//DebugMsg(info.toString());
	//DebugMsg(base.ghost_info_list.size());
	return;
}

void OnGhostExit__(CPLUGIN& base,const CPLUGINInput &in,CPLUGINOutput &out) {
	//MessageBox(0,L"OnGhostExit",L"",0);
	std::vector<CPLUGINGhostInfo>::iterator itr = base.ghost_info_list.begin(),
											last = base.ghost_info_list.end();
	for(;itr!=last;++itr)
	{
		if(itr->id == in.references[3])
		{
			//DebugMsg(itr->toString());
			base.ghost_info_list.erase(itr);
			//DebugMsg(base.ghost_info_list.size());
			break;
		}
	}
	out.result_code = PLUGINRESULT_NO_CONTENT;
	return;
}

void OnSecondChange__(CPLUGIN& base,const CPLUGINInput &in,CPLUGINOutput &out){
	if (!(pPlugin->event_queue.empty()))
	{
		CPLUGINQueueEvent evt = pPlugin->event_queue.front();
		pPlugin->event_queue.pop();
		out.event = evt.event_name;
		out.references.assign(evt.reference.begin(),evt.reference.end());
		out.result_code = PLUGINRESULT_OK;
	}
	else
	{
		out.result_code = PLUGINRESULT_NO_CONTENT;
	}
	return;
}

CPLUGIN::CPLUGIN(){
	setlocale( LC_ALL, "Japanese");
	system_function_table[L"installedplugin"] = &installedplugin__;
	system_function_table[L"ghostpathlist"] = &ghostpathlist__;
	system_function_table[L"balloonpathlist"] = &balloonpathlist__;
	system_function_table[L"headlinepathlist"] = &headlinepathlist__;
	system_function_table[L"pluginpathlist"] = &pluginpathlist__;
	system_function_table[L"OnGhostInfoUpdate"] = &OnGhostInfoUpdate__;
	system_function_table[L"OnGhostBoot"] = &OnGhostBoot__;
	system_function_table[L"OnGhostExit"] = &OnGhostExit__;
	system_function_table[L"OnSecondChange"] = &OnSecondChange__;
}

//------------------------------------------------------------------------------
//PLUGIN INTERFACES
//------------------------------------------------------------------------------
BOOL APIENTRY DllMain(
	HANDLE hModule,
	DWORD  ul_reason_for_call, 
	LPVOID lpReserved
){
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		GLOBAL::hInstance = (HINSTANCE)hModule;
		break;
	case DLL_THREAD_ATTACH:
		break;
	case DLL_THREAD_DETACH:
		break;
	case DLL_PROCESS_DETACH:
		unload();
		break;
	}
    return TRUE;
}

PLUGINAPI
HGLOBAL
PLUGINCDECL 
request(HGLOBAL h, long *len)
{
	std::string rq((char *)h, *len);
	GlobalFree(h);
	
	std::string re=pPlugin->request(rq);

	*len = (long)(re.size());
	h = GlobalAlloc(GMEM_FIXED, *len+1);
	if (h) {
		memcpy(h,re.c_str(),*len+1);
	}
	
	return h;
}

PLUGINAPI
BOOL
PLUGINCDECL
load(HGLOBAL h, long len)
{
	if(pPlugin!=NULL){
		unload();
	}
	pPlugin=new CPLUGIN();
	if (h) {
		std::string mpath;
		mpath.assign((char*)h,len);
		GlobalFree(h);
		pPlugin->setModulePath(mpath);
	}
	return pPlugin->load();
}

PLUGINAPI
BOOL
PLUGINCDECL
unload()
{
	if(pPlugin==NULL){
		return TRUE;
	}
	BOOL re=pPlugin->unload();
	delete pPlugin;
	pPlugin=NULL;
#ifdef _DEBUG
	_CrtDumpMemoryLeaks();
#endif
	return re;
}
