// ID:{DC65F728-23E0-4C12-872D-659CE692C70D}

#include <windows.h>
#include <sstream>
#include <boost/utility.hpp>
#include <boost/shared_ptr.hpp>
#include "cplugin.h"
#include "debug.h"

namespace
{
	// IDƕ\
	std::map<string_t,string_t> original_text;
}

BOOL CALLBACK EnumWindowsProc(HWND hwnd, LPARAM lParam)
{
	std::vector<TCHAR> buf(256);
	GetClassName(hwnd,&buf[0],buf.size());

	if (wcsncmp(L"MsnMsgrUIManager",&buf[0],16) == 0)
	{
		(*reinterpret_cast<std::vector<HWND>*>(lParam)).push_back(hwnd);
	}
	return TRUE;
}

std::vector<HWND> GetWindowList()
{
	std::vector<HWND> result;

	EnumWindows(EnumWindowsProc,reinterpret_cast<LPARAM>(&result));

	return result;
}

int SendText(std::vector<CPLUGINGhostInfo> ghost_list,bool exit)
{
	// MsnMsgrUIManagerNX
	std::vector<HWND> list = GetWindowList();
	std::vector<HWND>::iterator itr  = list.begin(),
								last = list.end();
	// 
	if(itr != last)
	{
		// Mpobt@m
		std::wstringstream stream;

		// f[^t
		stream << L"NowTalkingPlugin\\0" 
			   << L"Music\\0"
			   << (exit?L"0":L"1")<< L"\\0"
			   << L"{0}\\0";

		std::vector<CPLUGINGhostInfo>::iterator	itr2 = ghost_list.begin(),
												last2 = ghost_list.end();
		for (;itr2 != last2; ++itr2)
		{
			std::map<string_t,string_t>::iterator target = original_text.find(itr2->id);
			if (target != original_text.end())
				// IWieLXg
				stream << target->second;
			else
				stream << itr2->ghost_name;
			if (boost::next(itr2,1) != last2)
			{
				stream << L", ";
			}
		}

		stream << L"\\0\\0";

		// COPYDATASTRUCT\
		COPYDATASTRUCT cds;
		cds.dwData = 1351;// }WbNio[
		cds.cbData = 2*(stream.str().size()+1);// f[^̃TCY
		cds.lpData = reinterpret_cast<PVOID>(const_cast<wchar_t*>(stream.str().c_str()));// f[^ւ̎Q

		for(;itr != last;++itr)
		{
			// Messengerɑ΂WM_COPYDATAbZ[W𑗂
			SendMessage(*itr, WM_COPYDATA, NULL, (LPARAM)&cds);
		}
	}

	return 0;
}

/*
Reference0Fsakura HWND[\1]kero HWND[\1]3 HWND[\1]4 HWND ...
Reference1F݂̃S[Xg 
Reference2F݂̃VF
Reference3FS[XgID (Authorized SSTP(Owned SSTP)ő̂Ɠj
Reference4FS[Xg̃tpX
*/
void OnGhostBoot(CPLUGIN &base,const CPLUGINInput &in,CPLUGINOutput &out)
{
	out.result_code = PLUGINRESULT_NO_CONTENT;
	SendText(base.getGhostInfoList(),false);
}

void OnGhostExit(CPLUGIN &base,const CPLUGINInput &in,CPLUGINOutput &out)
{
	out.result_code = PLUGINRESULT_NO_CONTENT;
	SendText(base.getGhostInfoList(),false);
}

void OnGhostInfoUpdate(CPLUGIN &base,const CPLUGINInput &in,CPLUGINOutput &out)
{
	out.result_code = PLUGINRESULT_NO_CONTENT;
	SendText(base.getGhostInfoList(),false);
}
/*
R0 ID
R1 text
*/
void OnSetOriginalText(CPLUGIN &base,const CPLUGINInput &in,CPLUGINOutput &out)
{
	string_t text;
	if (in.references.size() == 0)
	{
		out.result_code = PLUGINRESULT_BAD_REQUEST;
		return;
	}

	out.result_code = PLUGINRESULT_NO_CONTENT;

	std::map<string_t,string_t>::iterator itr = original_text.find(in.references[0]);
	if (itr != original_text.end())
	{
		if (in.references.size() == 1)
		{
			itr->second.clear();
		}
		else
		{
			itr->second = in.references[1];
		}
	}
	else
	{
		if (in.references.size() >= 2)
		{
			original_text.insert(std::make_pair<string_t,string_t>(in.references[0],in.references[1]));
		}
	}
	SendText(base.getGhostInfoList(),false);
}

#define REGISTER(sym)	function_table[L#sym]=&sym

bool CPLUGIN::load()
{
	original_text.clear();
	version = L"NowTalkingPlugin/1.0";

	REGISTER(OnGhostBoot);
	REGISTER(OnGhostExit);
	REGISTER(OnGhostInfoUpdate);
	REGISTER(OnSetOriginalText);

	//DebugMsg(PLUGIN_FUNC::intToString(score->getUserScore()).c_str());
	return true;
}

bool CPLUGIN::unload()
{
	original_text.clear();
	SendText(this->ghost_info_list,true);
	//DebugMsg(L"Unload");
	return true;
}